#include <errno.h>
#include <unistd.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <lirc/lirc_client.h>
#include <glib.h>
#include "lircd_query.h"

void list_remote(gchar* remote, gpointer arg)
{
	int lircd = GPOINTER_TO_INT(arg);
	GSList *buttons;

	g_print("Remote Name: %s\n", remote);
	buttons = lirc_get_remote_buttons_full(lircd, remote);
	g_print("Remote Buttons:\n");
	g_slist_foreach(buttons, (GFunc)puts, NULL);
}

int main(int argc, char *argv[])
{
	GSList *remotes;
	int lircd;
	gchar *code;

	if((lircd=lirc_init("irexec", 0))==-1)
		return EXIT_FAILURE;

	remotes = lirc_get_remotes(lircd);
	if(remotes == NULL){
		fprintf(stderr, "Error getting the remote list\n");
	}
	g_slist_foreach(remotes, (GFunc)list_remote, GINT_TO_POINTER(lircd));

	g_print("Lisening for button press: (Hit Ctrl-C to quit)\n");

	while(lirc_nextcode(&code)==0)
	{
		if(code==NULL) continue;
		fputs(code, stdout);
		free(code);
	}

	lirc_deinit();
	exit(EXIT_SUCCESS);
}
